(use-package magit
  :ensure t
  :init
  ;; (taken from :open https://r0tty.org/git/dotfiles/emacs/tree/.emacs.d/config/development.el)
  (defun vcsh (repo)
    "Invoke magit on a vcsh repo. This requires an appropriate entry in `tramp-methods'."
    (interactive (let ((repos (delq nil
                                    (mapcar #'(lambda (name)
                                                (if (string-match ".git$" name)
                                                    (substring name 0 -4)
                                                  nil))
                                            (directory-files "~/.config/vcsh/repo.d")))))
                   (list (completing-read "Repository: " repos nil t))))
    (magit-status-internal (format "/vcsh:%s:" repo)))
  :config
  ;; Turn on flyspell when writing commit messages
  (add-hook 'git-commit-setup-hook 'git-commit-turn-on-flyspell))
